﻿  
function addLicense(fileInputId, infoTextId, addLicenseButtonId, deleteLicenseButtonId, divId) {

    let licenseFile = document.getElementById(fileInputId).files[0];  
    let text = document.getElementById(infoTextId);

    let reader = new FileReader();

    reader.readAsText(licenseFile);

    reader.onload = function () {
       let license = reader.result;


        $.ajax({
            url: "/MasterLicense/CreateMasterLicense",
            contentType: "application/x-www-form-urlencoded",
            method: "POST",
            data: {
                license: license
            },
            success: function (response) {
                text.innerText = response.message; 

                if (response.status === 1) {
                    addAlertMessage(response.message, divId, 'success');
                    // После добавления лицензии меняем тип кнопки на "удалить"
                    setButtonType(addLicenseButtonId, deleteLicenseButtonId, 'delete');
                }
                else
                    addAlertMessage(response.message, divId, 'warning');
            }
        }); 
    };
}

function deleteLicense(infoTextId, addLicenseButtonId, deleteLicenseButtonId, divId, licenseInfoId) {

    let text = document.getElementById(infoTextId); 

    $.ajax({
        url: "/MasterLicense/DeleteMasterLicense",
        contentType: "application/x-www-form-urlencoded",
        method: "DELETE",
        success: function (response) { 
            addAlertMessage(response, divId, 'warning');
            text.innerText = response;

            let licenseInfoDiv = document.getElementById(licenseInfoId);
            while (licenseInfoDiv.firstChild) {
                licenseInfoDiv.removeChild(licenseInfoDiv.firstChild);
            }

             // После удаления лицензии меняем тип кнопки на "добавить"
            setButtonType(addLicenseButtonId, deleteLicenseButtonId, 'add');
        }
    });    
}


function setButtonType(addLicenseButtonId, deleteLicenseButtonId, buttonType) {
    
    let addButton = document.getElementById(addLicenseButtonId);
    let deleteButton = document.getElementById(deleteLicenseButtonId);

    if (buttonType === "delete") {
        deleteButton.style.display = "block";
        addButton.style.display = "none";
    }
    else if (buttonType === "add") {
        deleteButton.style.display = "none";
        addButton.style.display = "block";
    }
}

function triggerFileSelect(fileInputId) {
    document.getElementById(fileInputId).click();
}; 

function addAlertMessage(text, divId, alertType) {

    let containerDiv = document.getElementById(divId);
    let div = document.createElement('div');

    div.style = 'margin-top: 10px';

    if (alertType === 'success') {
        div.className = "alert alert-success alert-dismissible";
    }
    else if (alertType === 'danger') {
        div.className = "alert alert-danger alert-dismissible";
    }
    else if (alertType === 'warning') {
        div.className = "alert alert-warning alert-dismissible";
    }
    else if (alertType === 'info') {
        div.className = "alert alert-info alert-dismissible";
    }
     
    div.innerText = text;

    let a = document.createElement('a');
    a.href = '#';
    a.className = 'close';
    a.setAttribute('data-dismiss', 'alert');
    a.setAttribute('aria-label', 'close')
    a.innerText = 'x';

    
    containerDiv.appendChild(div);
    div.appendChild(a);
}