﻿AbstractBlock = draw2d.shape.basic.Rectangle.extend({

    NAME: "AbstractBlock",

    onDragEnd: function (x, y, shiftKey, ctrlKey) {
        var _this = this;

        if (this.command !== null && this.canvas !== null) {
            this.command.setPosition(this.x, this.y);
            this.canvas.getCommandStack().execute(this.command);
            this.command = null;
        }

        this.isInDragDrop = false;
        this.panningDelegate = null;

        // notify all installed policies
        //
        if (this.canvas !== null) {
            this.editPolicy.each(function (i, e) {
                if (e instanceof draw2d.policy.figure.DragDropEditPolicy) {
                    e.onDragEnd(_this.canvas, _this, x, y, shiftKey, ctrlKey);
                }
            });
        }

        this.fireEvent("move", { figure: this, dx: 0, dy: 0 });
        this.fireEvent("change:x", { figure: this, dx: 0 });
        this.fireEvent("change:y", { figure: this, dy: 0 });

        // fire an event
        // @since 5.3.3
        this.fireEvent("dragend", { x: x, y: y, shiftKey: shiftKey, ctrlKey: ctrlKey });
    },

    setPersistentAttributes: function (memento) {
        this._super(memento);

        if (typeof memento.entities !== "undefined") {
            $.each(memento.entities, $.proxy(function (i, e) {
                var entity = this.addEntity(e.text);
                entity.id = e.id;
            }, this));
        }

        return this;
    }
});