﻿HighlightLineSelectionFeedbackPolicy = draw2d.policy.line.LineSelectionFeedbackPolicy.extend({

    NAME: "HighlightLineSelectionFeedbackPolicy",

    /**
     * @constructor 
     * Creates a new selection feedback policy for a line or connection
     */
    init: function (attr, setter, getter) {
        this._super(attr, setter, getter);
    },


    /**
     * @method
     * Called by the framework of the Policy should show a resize handle for the given shape
     *
     * @param {draw2d.Canvas} canvas The host canvas
     * @param {draw2d.Figure} figure The related figure
     * @param {Boolean} [isPrimarySelection]
     */
    onSelect: function (canvas, figure, isPrimarySelection) {
        this._super(canvas, figure, isPrimarySelection);
        figure.setColor("#0077DD");
    },

    /**
     * @method
     * 
     * @param {draw2d.Figure} figure the unselected figure
     */
    onUnselect: function (canvas, figure) {
        this._super(canvas, figure);
        figure.setColor("#000000");
    }
});