﻿StartBlock = draw2d.shape.basic.Rectangle.extend({

    NAME: "StartBlock",

    init: function (attr) {
        this._super($.extend({ resizeable: false, selectable: false, bgColor: "#FFFFFF", color: "#D9DAE2", stroke: 0.5, radius: 3 }, attr));

        this.setWidth(104);
        this.setHeight(76);

        if (attr && ("id" in attr)) 
            this.setId(attr.id);
        else
            this.setId("start");

        this.setUserData({});

        this.classLabel = new draw2d.shape.basic.Label({
            text: "Start",
            stroke: 0,
            radius: 0,
            bgColor: null,
            fontColor: "#000",
            resizeable: false
        });

        this.add(this.classLabel, new draw2d.layout.locator.CenterLocator());
        this.add(this.getStartBlockIcon(), new draw2d.layout.locator.LeftLocator({ margin: -25 }));
        this.add(this.getVerticalBarIcon(), new draw2d.layout.locator.LeftLocator({ margin: -8 }));
    },

    /**
     * @method 
     * Return an objects with all important attributes for XML or JSON serialization
     * 
     * @returns {Object}
     */
    getPersistentAttributes: function () {
        var memento = this._super();

        memento.name = this.classLabel.getText();
        memento.entities = [];

        return memento;
    },

    ///**
    // * @method 
    // * Read all attributes from the serialized properties and transfer them into the shape.
    // *
    // * @param {Object} memento
    // * @return
    // */
    setPersistentAttributes: function (memento) {
        this._super(memento);

        this.setName(memento.name);

        if (typeof memento.entities !== "undefined") {
            $.each(memento.entities, $.proxy(function (i, e) {
                var entity = this.addEntity(e.text);
                entity.id = e.id;
                //entity.getInputPort(0).setName("input_" + e.id);
                //entity.getOutputPort(0).setName("output_" + e.id);
            }, this));
        }

        return this;
    },

    getStartBlockIcon: function () {
        return new draw2d.shape.basic.Image({
            path: '/Images/BPM/GreenArrow.svg',
            width: 8,
            height: 12,
            minWidth: 8,
            minHeight: 12,
            boundingBox: new draw2d.geo.Rectangle(0, 0, 8, 12),
        });
    },

    getVerticalBarIcon: function () {
        return new draw2d.shape.basic.Image({
            path: '/Images/BPM/VerticalGradientBar.svg',
            width: 8,
            height: 76,
            minWidth: 8,
            minHeight: 76,
            boundingBox: new draw2d.geo.Rectangle(0, 0, 8, 76),
        });
    }
});