﻿let EmailMonitoringBlockContentHandler = {

    initializeEmailMonitoringModal: function () {

        this.initializeBlockFooter();

        let emailMonitoringPropertiesElement = document.getElementById("emailMonitoringProperties");

        while (modalBlockParametersElement.lastElementChild) {
            modalBlockParametersElement.lastElementChild.style.display = "none";
            modalParametersContainerElement.appendChild(modalBlockParametersElement.lastElementChild);
        }

        modalBlockParametersElement.appendChild(emailMonitoringPropertiesElement);
        emailMonitoringPropertiesElement.style.display = "block";

        let emailMonitoringFiltersTableId = "emailMonitoringEmailFilters";

        let emailFiltersTable = document.getElementById(emailMonitoringFiltersTableId);
        emailFiltersTable.innerHTML = "";

        if (selectedBlock.userData) {
            if (selectedBlock.userData.mailFolder) {
                let mailFolderInputElement = document.getElementById("emailMonitoringMailFolder");
                mailFolderInputElement.value = selectedBlock.userData.mailFolder;
            }

            let markAsReadElement = document.getElementById("MarkAsRead");

            if (selectedBlock.userData.markAsRead != undefined) {
                markAsReadElement.checked = selectedBlock.userData.markAsRead;
            } else {
                markAsReadElement.checked = true;
            }

            if (selectedBlock.userData.filterParameters) {
                for (let filterParam of selectedBlock.userData.filterParameters) {
                    this.addEmailFilterRow(emailMonitoringFiltersTableId, filterParam.FilterName, filterParam.FilterValue);
                }
            }
        }
    },

    initializeBlockFooter: function () {
        let saveBtn = document.createElement("button");
        saveBtn.className = "modal-blackButton";
        saveBtn.style.width = "50%";
        saveBtn.innerHTML = localizedSaveChangesString;

        saveBtn.onclick = function () {
            modal.style.display = "none";
            EmailMonitoringBlockContentHandler.saveEmailMonitoringProperties("emailMonitoringMailFolder");

            validateProcessScheme(null);
        }

        while (modalFooter.firstChild) {
            modalFooter.removeChild(modalFooter.firstChild);
        }
        modalFooter.appendChild(saveBtn);
    },

    saveEmailMonitoringProperties: function (mailFolderElementId) {
        let mailFolderElement = document.getElementById(mailFolderElementId);

        selectedBlock.userData.mailFolder = mailFolderElement.value;

        let emailMonitoringPropertiesElement = document.getElementById("emailMonitoringProperties");

        let markAsReadElement = emailMonitoringPropertiesElement.querySelector("#MarkAsRead");
        selectedBlock.userData.markAsRead = markAsReadElement.checked;

        let emailFiltersList = [];
        let filterElements = emailMonitoringPropertiesElement.querySelectorAll("[data-email-filter]");

        for (let element of filterElements) {
            if (element.value) {
                let filterName = element.dataset.emailFilter;

                emailFiltersList.push(
                    {
                        FilterName: filterName,
                        FilterValue: element.value
                    });
            }
        }

        selectedBlock.userData.filterParameters = emailFiltersList;

        selectedBlock.userData.blockName = blockNameInputElement.value;

        setBlockNameLabel(selectedBlock, "blockName", blockNameInputElement.value);
    },

    addEmailFilterRow: function (emailFilterTableElementId, selectedFilterName = null, filterValue = null) {
        let emailMonitoringPropertiesElement = document.getElementById("emailMonitoringProperties");
        let emailFilterTableElement = document.getElementById(emailFilterTableElementId);

        let filterRow = document.createElement("tr");

        let filterSelect = emailMonitoringPropertiesElement.querySelector("[data-parameters-template]").cloneNode(true);
        delete filterSelect.dataset.parametersTemplate;
        filterSelect.style.display = "block";
        filterSelect.className = "parametersSelect";
        filterSelect.addEventListener("change", EmailMonitoringBlockContentHandler.onFilterChanged);

        if (selectedFilterName)
            filterSelect.value = selectedFilterName

        let filterSelectCell = document.createElement("td");
        filterSelectCell.appendChild(filterSelect);

        filterRow.appendChild(filterSelectCell);

        let filterInputElement = document.createElement("input");
        filterInputElement.dataset.emailFilter = filterSelect.value;
        filterInputElement.className = "parametersInput";

        if (filterValue)
            filterInputElement.value = filterValue;

        if (filterSelect.value === "SentSince" || filterSelect.value === "SentBefore")
            filterInputElement.type = "date";

        let inputCell = document.createElement("td");
        inputCell.appendChild(filterInputElement);

        filterRow.appendChild(inputCell);

        let removeRowButton = document.createElement("input");
        removeRowButton.type = "button";
        removeRowButton.className = "modal-transparentButton";
        removeRowButton.value = "X";
        removeRowButton.addEventListener("click", this.removeRow);

        let removeRowButtonCell = document.createElement("td");
        removeRowButtonCell.appendChild(removeRowButton);

        filterRow.appendChild(removeRowButtonCell);

        emailFilterTableElement.appendChild(filterRow);
    },

    onFilterChanged: function (e) {
        let selectElement = e.target;

        let currentRow = selectElement.closest("tr");
        let filterInput = currentRow.querySelector("input");

        filterInput.dataset.emailFilter = selectElement.value;

        if (selectElement.value === "SentSince" || selectElement.value === "SentBefore")
            filterInput.type = "date";
        else
            filterInput.type = "text";
    },

    removeRow: function (e) {
        let filterRow = e.target.closest("tr");
        filterRow.remove();
    }

}