﻿let SendEmailBlockContentHandler = {

    emailBodyEditor: null,

    initializeSendEmailModal: function () {

        this.initializeBlockFooter();

        if (!this.emailBodyEditor) {
            ClassicEditor
                .create(document.querySelector("#sendEmailBody"), {
                    mention: {
                        feeds: [
                            {
                                marker: "$",
                                feed: ParametersInTextHelper.getCKEditorParametersList,
                                itemRenderer: ParametersInTextHelper.getCKEditorTagElement
                            }
                        ]
                    },
                    language: currentLanguage
                })
                .then(newEditor => {
                    SendEmailBlockContentHandler.emailBodyEditor = newEditor;
                    ParametersInTextHelper.applyCKEditorMentionCustomization(SendEmailBlockContentHandler.emailBodyEditor);

                    if (selectedBlock && selectedBlock.userData && selectedBlock.userData.emailBody)
                        newEditor.setData(selectedBlock.userData.emailBody);
                })
                .catch(error => {
                    console.error(error);
                });
        }

        let sendEmailPropertiesElement = document.getElementById("sendEmailProperties");

        while (modalBlockParametersElement.lastElementChild) {
            modalBlockParametersElement.lastElementChild.style.display = "none";
            modalParametersContainerElement.appendChild(modalBlockParametersElement.lastElementChild);
        }

        modalBlockParametersElement.appendChild(sendEmailPropertiesElement);
        sendEmailPropertiesElement.style.display = "block";

        let recipientEmailInputElement = document.getElementById("sendEmailRecipientEmail");
        let emailSubjectInputElement = document.getElementById("sendEmailSubject");
        let emailBodyInputElement = document.getElementById("sendEmailBody");

        ParametersInTextHelper.applyTagify(emailSubjectInputElement);

        if (selectedBlock.userData) {
            if (selectedBlock.userData.recipientEmail)
                recipientEmailInputElement.value = selectedBlock.userData.recipientEmail;
            else
                recipientEmailInputElement.value = "";

            if (selectedBlock.userData.emailSubject)
                emailSubjectInputElement.value = selectedBlock.userData.emailSubject;
            else
                emailSubjectInputElement.value = "";

            if (selectedBlock.userData.emailBody) {
                emailBodyInputElement.value = selectedBlock.userData.emailBody;

                if (this.emailBodyEditor)
                    this.emailBodyEditor.setData(selectedBlock.userData.emailBody);
            }
            else {
                emailBodyInputElement.value = "";

                if (this.emailBodyEditor)
                    this.emailBodyEditor.setData("");
            }
        }
    },

    initializeBlockFooter: function () {
        let saveBtn = document.createElement("button");
        saveBtn.className = "modal-blackButton";
        saveBtn.style.width = "50%";
        saveBtn.innerHTML = localizedSaveChangesString;

        saveBtn.onclick = function () {
            modal.style.display = "none";
            SendEmailBlockContentHandler.saveSendEmailProperties("sendEmailRecipientEmail", "sendEmailSubject", "sendEmailBody");

            validateProcessScheme(null);
        }

        while (modalFooter.firstChild) {
            modalFooter.removeChild(modalFooter.firstChild);
        }
        modalFooter.appendChild(saveBtn);
    },

    saveSendEmailProperties: function (recipientEmailElementId, subjectElementId, bodyElementId) {
        let recipientEmailInputElement = document.getElementById(recipientEmailElementId);
        let emailSubjectInputElement = document.getElementById(subjectElementId);
        let emailBodyInputElement = document.getElementById(bodyElementId);

        selectedBlock.userData.recipientEmail = recipientEmailInputElement.value;
        selectedBlock.userData.emailSubject = emailSubjectInputElement.value;

        if (this.emailBodyEditor)
            selectedBlock.userData.emailBody = this.emailBodyEditor.getData();
        else
            selectedBlock.userData.emailBody = emailBodyInputElement.value;

        selectedBlock.userData.blockName = blockNameInputElement.value;

        setBlockNameLabel(selectedBlock, "blockName", blockNameInputElement.value);
    }
}