﻿const processHubConnection = {

    blockExecutionHubConnection: null,

    processFinishedMessage: "Process finished",

    processedBlocksData : {},

    currentBlock : undefined,

    subscribeToBlockExecute: function () {

        if (!this.blockExecutionHubConnection) {
            let hubUrl = '/dataevents';
            this.blockExecutionHubConnection = new signalR.HubConnectionBuilder()
                .withUrl(hubUrl)
                .build();

            this.blockExecutionHubConnection.on('HighlightExecutingBlock', function (processId, blockId) {

                if (!isCanvasDisabled) {
                    isCanvasDisabled = true;
                    disableForm();
                }

                let documentProcessId = document.getElementById("Id").value;

                if (documentProcessId == processId)
                    processHubConnection.highlightBlock(blockId);
            });

            this.blockExecutionHubConnection.on('FinishProcessExecuting', function (processId) {
                let documentProcessId = document.getElementById("Id").value;

                if (documentProcessId == processId)
                    processHubConnection.finishProcessExecuting();
            });

            this.blockExecutionHubConnection.start().then(() => {
                this.blockExecutionHubConnection.invoke("Subscribe", "processes");
            });
        }
    },

    subscribeToProcessHistoryUpdate: function () {
        let hubUrl = '/dataevents';
        const hubConnection = new signalR.HubConnectionBuilder()
            .withUrl(hubUrl)
            .build();

        hubConnection.on('ProcessHistoryUpdate', function () {
            location.reload();
        });

        hubConnection.start().then(() => {
            hubConnection.invoke("Subscribe", "processes");
        });
    },

    highlightBlock: function (blockID) {
        let targetBlock = canvas.view.getFigure(blockID);

        if (!this.processedBlocksData[blockID])
            this.processedBlocksData[blockID] = { color: targetBlock.getColor(), stroke: targetBlock.getStroke() };

        if (this.currentBlock)
            this.currentBlock.setColor("#33BB33");

        targetBlock.setColor("#F5C033");
        targetBlock.setStroke(3);

        this.currentBlock = targetBlock;
    },

    finishProcessExecuting: function () {
        if (this.currentBlock)
            this.currentBlock.setColor("#33BB33");

        showSnackbar("info", this.processFinishedMessage);

        for (let blockId in this.processedBlocksData) {
            let blockData = this.processedBlocksData[blockId];
            let block = canvas.view.getFigure(blockId);

            block.setColor(blockData.color);
            block.setStroke(blockData.stroke);
        }

        processHubConnection.processedBlocksData = {};
        this.currentBlock = null;

        enableCanvasOnFinish();
    }
}