﻿function GetHubConnection() {
    let hubUrl = '/dataevents';
    const hubConnection = new signalR.HubConnectionBuilder()
        .withUrl(hubUrl)
        .build();

    return hubConnection;
}

function SubscribeToAgentUpdates() {
    const hubConnection = GetHubConnection();
    hubConnection.on('AgentStatusUpdate', function (id, name, isConnect) {
        UpdateAgentStatus(id, isConnect);
    });

    hubConnection.start().then(() => {
        // Подписываемся на изменения в Agents
        hubConnection.invoke("Subscribe", "Agents");
    });
}

function SubscribeToScreenshotReceivedEvent() {
    const hubConnection = GetHubConnection();

    hubConnection.on('ScreenshotReceived', function (agentName, imageData) {
        if (modelAgentName === agentName) {
            let imgElement = document.getElementById("ScreenshotPlace");
            imgElement.src = "data:image/jpg;base64," + imageData;
        }
    });
}

function UpdateAgentStatus(id, status) {
    $('#Table > tbody > tr').each(function () {
        if (id == $(this).attr("data-agent-id")) {
            $(this).find('#AgentConnectionStatus').attr("src", status ? "/Images/ON.svg" : "/Images/OFF.svg");
        }
    });
}

function withCredentialChecked(panelId) {
    
    let panel = document.getElementById(panelId);

    if (panel.style.display == 'block')
        panel.style.display = 'none';
    else
        panel.style.display = 'block';
}

function RequestScreenshot(agentName) {
    $.ajax({
        url: "/Agents/RequestAgentScreenshot",
        contentType: "application/x-www-form-urlencoded",
        method: "GET",
        data: {
            agentName: agentName
        },
        success: function (response) {
            console.log(response);
        }
    });
}

function disconnectAgent(agentId) {
    $.ajax({
        url: "Agents/Disconnect",
        contentType: "application/x-www-form-urlencoded",
        method: "POST",
        data: {
            agentId: agentId
        },
        success: function (response) {
            document.location.reload();
        }
    });
}